﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebForm1.aspx.cs" Inherits="MultiLineTextEditorCaretToEnd.WebForm1" %>

<%@ Register Assembly="Infragistics45.Web.v21.2, Version=21.2.20212.9, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
     <style type="text/css">
        .noWrapCellStyle {
             white-space:nowrap;
                  
        }

        .activeEditCell {
            white-space:normal;
            background:White !important;
	        border:solid 1px #AAAAAA !important;
            
            
        }
    </style>    
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
            <ig:WebDataGrid Width="700px" ID="WebDataGrid1" runat="server" Height="450px" AutoGenerateColumns="False" DataKeyFields="EmployeeID"
                 ItemCssClass="noWrapCellStyle" OnInitializeRow="WebDataGrid1_InitializeRow">
                <EditorProviders>
                     <ig:TextEditorProvider ID="WebDataGrid1_TextEditorProvider1">
                        <EditorControl ClientIDMode="Predictable" SelectionOnFocus="CaretToEnd" TextMode="MultiLine"></EditorControl>
                    </ig:TextEditorProvider>
                </EditorProviders>
                <Behaviors>
                    <ig:Activation ActiveCellCssClass="activeEditCell">
                    </ig:Activation>
                    <ig:EditingCore AutoCRUD="true">
                        <Behaviors>
                            <ig:CellEditing>
                                <ColumnSettings>
                                    <ig:EditingColumnSetting ColumnKey="Site" EditorID="WebDataGrid1_TextEditorProvider1" />
                                </ColumnSettings>
                                <CellEditingClientEvents ExitingEditMode="WebDataGrid1_CellEditing_ExitingEditMode"  EnteringEditMode="WebDataGrid1_CellEditing_EnteredEditMode"
                                     ExitedEditMode="WebDataGrid1_CellEditing_ExitedEditMode"/>
                            </ig:CellEditing>
                            <ig:RowAdding>
                            </ig:RowAdding>
                        </Behaviors>
                    </ig:EditingCore>
                </Behaviors>
                <Columns>
                    <ig:BoundDataField Key="EmployeeID" Header-Text="EmployeeID">
                        <Header Text="EmployeeID"></Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField Key="Name" Header-Text="Name">
                        <Header Text="Name"></Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField Key="OnSite" Header-Text="OnSite">
                        <Header Text="OnSite"></Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField Key="DateOfHire" Header-Text="DateOfHire">
                        <Header Text="DateOfHire"></Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField Key="Department" Header-Text="Department">
                        <Header Text="Department"></Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField Key="Site" Header-Text="Site" EnableMultiline="True">
                        <Header Text="Site"></Header>
                    </ig:BoundDataField>
                </Columns>
            </ig:WebDataGrid>
            <asp:Button ID="Button1" runat="server" Text="Add Row"  OnClientClick="addRowFunc(); return false;"/>
        </div>
    </form>
    <script type="text/javascript" id="igClientScript">
        function WebDataGrid1_CellEditing_ExitingEditMode(sender, eventArgs) {
            if (eventArgs.getCell().get_column().get_key() == "Site") {
                if (eventArgs.get_browserEvent().keyCode == 13) {
                    eventArgs.set_cancel(true);
                }
            }

        }

        function WebDataGrid1_CellEditing_EnteredEditMode(sender, eventArgs) {
            var cell = eventArgs.getCell();
            //if (cell.get_column().get_key() == "Site") {
                //    var cellValue = cell.get_value() + "\n" + "\n" + "\n" + "\n" + "\n" + "\n" + "\n" + "\n" + "\n" + "\n";
                //    cell.set_value(cellValue);                
            //}

        }

        function WebDataGrid1_CellEditing_ExitedEditMode(sender, eventArgs) {
            var cell = eventArgs.getCell();
            if (cell.get_column().get_key() == "Site") {
                var cellValue = cell.get_value();
                cellValue = cellValue.trim();
                cell.set_value(cellValue);
            }
        }

        function addRowFunc() {
            var names = ["Tom", "Bill", "Krum", "Nataliya", "Valentina"];
            var grid = $find("WebDataGrid1");
            var rows = grid.get_rows();
            var rowIndex = grid.get_rows().get_length() + 1;
            var date = new Date();
            var row = new Array(rowIndex, names[rowIndex % 5], true, date, rowIndex % 8, "");
            rows.add(row);
        }

    </script>
</body>
</html>
